<?php

function breakLongWords($str, $maxLength, $char){

  $wordEndChars = array(" ", "\n", "\r", "\f", "\v", "\0");
  $count = 0;
  $newStr = "";
  $openTag = false;

  for ($i=0; $i<strlen($str); $i++) {
    $newStr .= $str{$i};   

    if (!in_array($str{$i}, $wordEndChars)) {
      $count++;
      if ($count==$maxLength){
        $newStr .= $char;
        $count = 0;
      }
    } else {
      $count = 0;
    }
  } 

  return $newStr;

}



function generate_hash($digits) {

  $s = 0;
  $hash = "";
  while ($s <= $digits) {
    $num = rand(0, 9);
    $hash .= $num;
    $s++;
  }
  return $hash;

}



function ib_bbcode($text) {

  $inhalt = str_replace('[B]', '<b>', $text);
  $inhalt = str_replace('[/B]', '</b>', $inhalt);
  $inhalt = str_replace('[U]', '<u>', $inhalt);
  $inhalt = str_replace('[/U]', '</u>', $inhalt);
  $inhalt = str_replace('[I]', '<i>', $inhalt);
  $inhalt = str_replace('[/I]', '</i>', $inhalt);

  // Links
  $pattern = "#(\[URL\]){1}((http://)?((www.)?([a-zA-Z0-9\.\#+-=/&?_%\: ]){6,}))(\[/URL\]){1}#is";
  $repl = "<a href=\"http://$4\" target=\"_blank\">$2 </a>";
  $inhalt = preg_replace($pattern, $repl, $inhalt);

  // Grafiken
  $pattern = "#(\[IMG\]){1}((http://)?((www.)?([a-zA-Z0-9\.\#+-=/&?_%\: ]){6,}))(\[/IMG\]){1}#is";
  $repl = "<a href=\"http://$4\" target=\"_blank\"><img src=\"http://$4\" alt=\"img\" width=\"200\" /> </a>";
  $inhalt = preg_replace($pattern, $repl, $inhalt); 

  return $inhalt;

}



function show_pages($mode, $fname, $page, $seiten) {

  $str_output =  "<p>";

  if ($mode == "modern") {
    if ($page >= 3) {
      $str_output .= "<a href=\"".$fname."page=1\"><<</a> | ";
    }
    if ($page >= 2) {
      $str_output .=  "<a href=\"".$fname."page=".($page-1)."\"><</a> | ";
    }
    $str_output .=  "<b>".$page."</b>";
    if ($page <= ($seiten-1)) {
      $str_output .=  " | <a href=\"".$fname."page=".($page+1)."\">></a>";
    }
    if ($page <= ($seiten-2)) {
      $str_output .=  " | <a href=\"".$fname."page=".($seiten)."\">>></a>";
    }
  } else {
    $i = 1;
    while ($i <= $seiten) {
      if ($page != $i) {
	$str_output .=  " <a href=\"".$fname."page=".$i."\">".$i."</a> ";
      } else {
	$str_output .= " <b>".$i."</b> ";
      }
      $i++;
    }

  }

  $str_output .=  "</p>";

  return $str_output;

}



function show_smileys($pre, $pos, $rows, $path) {

  $sql = "SELECT * FROM ".$pre."smileys";
  $result = mysql_query($sql);
  $x = 1;
  $str_output = "<span class=\"smileys\"><br style=\"clear: both;\" />";

  while ($row = mysql_fetch_assoc($result)) {
    $code = " ".$row['smileycode'];
    $img = $row['smileyimg'];
    if (file_exists($path."images/smileys/".$img)) {
      $size = getimagesize($path."images/smileys/".$img);
      $smheight = $size[1];
      $smwidth = $size[0]+7;
      $str_output .= "<input type=\"button\" style=\"margin-top: 7px; background:url(".$path."images/smileys/".$img.") no-repeat; width: ".$smwidth."px; height: ".$smheight."px; border: 0px; \" onclick=\"bbcode('', '".$code."')\" />\n";
      if ($x == $rows) {
	$str_output .= "<br />";
	$x = 0;
      }
      $x++;
    }
  }

  $str_output .= "</span><br style=\"clear: both;\" />";

  return $str_output;

}



function get_settings($ibnr) {

  $pre = "ib".$ibnr."_";
  $sql = "SELECT * FROM ".$pre."settings";
  $query = mysql_query($sql) or die("Fehler: ".mysql_error());
  $set = mysql_fetch_assoc($query);
  $set['pre'] = $pre;
  $set['eps'] = $set['entriespersite'];
  $_SESSION['captcha_type'] = $set['captcha'];

  return ($set);

}



function get_section() {

  if (!isset($_GET['section'])) {
    $section = "start";
  } else {
    $section = strip_tags($_GET['section']);
  }

  return $section;

}



function callback($matches) {
  $match = $matches[1].$matches[2].str_replace(' ', '', $matches[3]).$matches[4];
  return $match;
}



function remove_spaces($entry) {

  $pattern = '#(<a.*?href=)("|\')(.*?)(\2[^>]*>)#s';
  $entry = preg_replace_callback($pattern, 'callback', $entry);
  $pattern = '#(<img.*?src=)("|\')(.*?)(\2[^>]*>)#s';
  $newentry = preg_replace_callback($pattern, 'callback', $entry);
  return $newentry;

}


function br2nl($content) {

  $content = str_replace("<br />", "\n", $content);
  $content = str_replace("<br>", "\n", $content);
  return $content;

}


function handle_entry($entrydata, $pre, $ibnr) {

  extract($entrydata);

  $blockips = array("37.201.129.114");
  if (in_array($_SERVER['REMOTE_ADDR'], $blockips)) die("SPAM");

  $settings = get_settings($ibnr);
  extract($settings);

  include("lang/".$lang.".php");

  $content = nl2br($content);
  $content = str_replace("\\n", "<br />", $content);
  $content = str_replace("\\r", "", $content);

  if (substr($homepage, 0, 7) != "http://") {
    $homepage = "http://".$homepage;
  }

  if (!strpos($email, "@") or strlen($email) <= 10) {
    $email = "";
  } 

  $time_now = time();
  $time_needed = $time_now - $time1;
  $IP = $_SERVER['REMOTE_ADDR'];
  $spamcontent = 0;
  if ($captcha != 0) {
    $sec  = mysql_real_escape_string(strip_tags($sec));
  }

  if ($flood == "1") {
    $usersql = "SELECT Datum FROM ".$pre."entries WHERE IP = '$IP' order by Datum DESC";
    $userresult = mysql_query($usersql) or die(mysql_error());
    $user = mysql_fetch_assoc($userresult);
    $sincelastpost = time()-$user['Datum'];
  }


  if (empty($autor)) {
    $err_msg = $error."! ".$ind_err_noname; 
  } elseif (empty($content)) {
    $err_msg = $error."! ".$ind_err_nocontent;
  } elseif ($captcha != 0 and strtolower($sec) != strtolower($_SESSION['right_str'])) {
    $err_msg = $error."! ".$ind_err_nocaptcha;
  } elseif (strlen($content) > $maxchars) {
    $toomuch = strlen($content) - $maxchars;
    $err_msg = $ind_err_toomuch1." (".$toomuch.")".$ind_err_toomuch2;
  } elseif ($time_needed < 3 or $hiddenfield == "1" and $themen != "" or $hiddenfield == "1" and $thema != "" or !is_numeric($time1)) {
    die("Spam!");
  } elseif ($flood == "1" and mysql_num_rows($userresult) and $sincelastpost <= $floodtime) {
    $wait = $floodtime-$sincelastpost;
    $err_msg = $error."! ".$ind_flood1." ".$wait." ".$ind_flood2;
  } else {

    $err_msg = 0;

    if ($spamfilter != 0) {
      $phrases = explode(",", $spamphrases);
      foreach ($phrases as $word) {
	if (strpos(strtolower($content), strtolower($word)) !== FALSE) {
	  $spamcontent = 1;
	}
      }
    }
  }

  if ($activate == "1" or $spamfilter == 1 and $spamcontent == 1) {
    $status = "0";
  } else {
    $status = "1";
  }

  $str_output['e_error'] = $err_msg;
  $str_output['e_homepage'] = $homepage;
  $str_output['e_email'] = $email;
  $str_output['e_autor'] = $autor;
  $str_output['e_content'] = $content;
  $str_output['e_status'] = $status;
  $str_output['e_time'] = $time_now;
  $str_output['e_ip'] = $IP;
  $str_output['e_spam'] = $spamcontent;

  return($str_output);

}



function show_entry ($inhalt, $pre, $bbcode, $path) {

  // BBCode
  if ($bbcode == "1") {
    $inhalt = ib_bbcode($inhalt);
  }

  $inhalt = str_replace("\\", "", $inhalt);


  $inhalt = remove_spaces(breakLongWords($inhalt, 30, " "));

  // Smileys
  $smileysql = "SELECT * FROM ".$pre."smileys";
  $smileyresult = mysql_query($smileysql) or die("Fehler: ".mysql_error());

  while ($smileyrow = mysql_fetch_assoc($smileyresult)) {
    $smileycode = $smileyrow['smileycode'];
    $smileyimg = "<img src=\"".$path."images/smileys/".$smileyrow['smileyimg']."\" />";
    $inhalt = str_replace($smileycode, $smileyimg, $inhalt);
  }

  // Badwords
  $badsql = "SELECT * FROM ".$pre."badwords";
  $badresult = mysql_query($badsql) or die("Fehler: ".mysql_error());

  while ($badrow = mysql_fetch_assoc($badresult)) {
    $inhalt = str_replace($badrow['Badword'], $badrow['Ersatz'], $inhalt);
  }

  return $inhalt;

}



function bbcode_buttons($bbcode, $path) {

  if ($bbcode == "1") {
    $bbcode_buttons = "<input type=\"button\" style=\"background:url(".$path."images/bbcode_bold.gif); width: 20px; height: 20px;\" onclick=\"bbcode('[B]', '[/B]')\" />
    <input type=\"button\" style=\"background:url(".$path."images/bbcode_italic.gif); width: 20px; height: 20px; \" onclick=\"bbcode('[I]', '[/I]')\" />
    <input type=\"button\" style=\"background:url(".$path."images/bbcode_underline.gif); width: 20px; height: 20px; \" onclick=\"bbcode('[U]', '[/U]')\" />
    <input type=\"button\" style=\"background:url(".$path."images/bbcode_url.gif); width: 20px; height: 20px; \" onclick=\"bbcode('[URL]', '[/URL]')\" />
    <input type=\"button\" style=\"background:url(".$path."images/bbcode_image.gif); width: 20px; height: 20px; \" onclick=\"bbcode('[IMG]', '[/IMG]')\" />
    <br />";
  } else {
    $bbcode_buttons = "";
  }

  return $bbcode_buttons;  

}



function statistics($pre, $eps) {

  $select = "select ID from ".$pre."entries WHERE Status = '1'";
  $result = mysql_query($select) or die(mysql_error());
  $return['anzahl'] = mysql_num_rows($result);

  if (!isset($_GET['page']) or $_GET['page'] < 0) {
    $return['page'] = 1;
  } else {
    $return['page'] = (int)$_GET['page'];
  }

  $return['page2'] = ($return['page']-1)*$eps;
  $return['seiten'] = ceil($return['anzahl']/$eps);

  return $return;

}


function get_timezone() {

  if (date_default_timezone_get()) {
    $timezone = date_default_timezone_get();
  } else {
    $timezone = "Europe/Berlin";
  }

  date_default_timezone_set($timezone);

}


?>