<?php
$version = "1.73";



if (isset($_GET['action']) and $_GET['action'] == "mysql" and isset($_POST['submit'])) {
  @setcookie(dbhost, $_POST['dbhost']);
  @setcookie(dbname, $_POST['dbname']);
  @setcookie(dbuser, $_POST['dbuser']);
  @setcookie(dbpw, $_POST['dbpw']);
}

?>


<!DoCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">


<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<title>Installation des Icybook <?php echo $version; ?></title>

<style type="text/css">
body {
  background-color: #EFFBFB;
  margin: 50px;
  font-family: "Trebuchet MS", Verdana;
  color: #333333;
}

a, a:visited, a:link {
  color: #000000;
  text-decoration: underline;
}

a:active, a:hover {
  color: #838383;
  text-decoration: none;
}

h1, h2 {
  margin-top: 0px;
  text-shadow: #BBBBBB 0.1em 0.1em 0.1em;
  color: #144470;
}

h2 {
  margin-bottom: 50px;
}

.weiter {
  margin-top: 50px;
}

.error {
  background-color: #FF6347;
  border: 1px solid #FF0000;
  border-radius: 7px;
  padding: 5px;
}

.progressbar {
  width: 100%;
  height: 30px;
  border: 1px solid #CCCCCC;
  padding: 0px;
}

.progressbar span {
  height: 30px;
  background-color: #AAF0FF;
  margin: 0px;
  line-height: 30px;
  display: block;
}

.progressbar strong {
  padding-left: 10px;
  text-align: center;
}
  

.clear {
  clear: both;
}

ul .compl {
  background-color: #AAF0FF;
}

h4 {
  margin-bottom: 50px;
}

</style>

</head>

<body>

<img src="images/logo.png" style="float: left;" alt="Logo" />

<h1>Icybook <?php echo $version; ?></h1>
<h2>Installation</h2>


<?php

if (!isset($_GET['action'])) { ?>

<fieldset>
  <legend>Start</legend>

  <div class="progressbar">
    <span style="width: 0%;"><strong>0%</strong></span>
  </div>

  <p>Sie sind im Begriff, das Icybook <?php echo $version; ?> zu installieren.<br />
     Sollten Sie bereits eine &auml;ltere Version haben, f&uuml;hren Sie diese Installation nicht aus sondern <a href="http://icybook.de" title="Download" target="blank">downloaden Sie das Update-Paket von der Herstellerseite.</a></p>

  <p>F&uuml;r die Installation m&uuml;ssen Cookies in Ihrem Browser aktiviert sein!</p>

  <p class="weiter"><b><a href="install.php?action=mysql" title="Weiter">&raquo; Weiter</a></b></p>

</fieldset>

<?php }





if (isset($_GET['action']) and $_GET['action'] == "mysql") { ?>


<fieldset>
  <legend>MySQL-Daten</legend>

  <div class="progressbar">
    <span style="width: 25%;"><strong>25%</strong></span>
  </div>

  <?php


  if (isset($_POST['submit'])) {

    $dbhost = $_POST['dbhost'];
    $dbname = $_POST['dbname'];
    $dbuser = $_POST['dbuser'];
    $dbpw = $_POST['dbpw'];


    if (empty($dbhost) or empty($dbname) or empty($dbuser) or empty($dbpw)) {
      echo "<p class=\"error\">Fehler: F&uuml;llen Sie bitte alle Felder aus!</p>";
      $error = 1;
    } elseif (!@mysql_connect($dbhost, $dbuser, $dbpw)) {
      echo "<p class=\"error\">Fehler:</b> Konnte nicht verbinden! Host, User oder Passwort stimmt nicht!</p>";
      $error = 1;
    } elseif(!mysql_selectdb($dbname)) {
      echo "<p class=\"error\">Fehler:</b> Diese Datenbank existiert nicht!</p>";
      $error = 1;
    } else {

      $write = "

<?php
// Serverdaten\n
\$host = \"".$_POST['dbhost']."\";
\$db   = \"".$_POST['dbname']."\";
\$user = \"".$_POST['dbuser']."\";
\$dbpw = \"".$_POST['dbpw']."\";







// include-Pfad (bitte ReadMe lesen)\n
\$path = \"\";



// Ab hier nichts mehr verndern!
\$connect = mysql_connect(\$host, \$user, \$dbpw) or die(\"Konnte nicht verbinden! Ursache:<br />\".mysql_error());
\$selectdb = mysql_selectdb(\$db) or die(\"Konnte Datenbank \".\$db.\" nicht auswhlen! Ursache:<br /> \".mysql_error());
\$version = \"".$version."\";
";

      $file = "inc/gbconfig.php";

      if (@$handlew = fopen($file, w)) {
	fwrite($handlew, $write);
	$error = 0;
	echo "<p>Die MySQL-Daten wurden erfolgreich &uuml;bernommen.</p>
		<p class=\"weiter\"><a href=\"install.php?action=install\">&raquo; Weiter zum n&auml;chsten Schritt</a></p>";
		$error = 0;
      } else {
	echo "<p class=\"error\">Fehler:</b> Die erforderlichen Zugriffsrechte (777) f&uuml;r die inc/gbconfig.php sind nicht gesetzt!</p>";
	$error = 1;
      }

    } 

  }


  if (isset($error) and $error == 1 or !isset($error)) { 

    if (!isset($error)) {
      echo "<p>In diesem Schritt m&uuml;ssen  Sie die Daten Ihres MySQL-Servers eintragen. Sollte es beim Absenden zu einer Fehlermeldung kommen, stellen Sie die Zugriffsrechte der inc/gbconfig.php auf 777.</p>";
    } ?>


      <form action="install.php?action=mysql" method="post"><table>
	<tr>
	  <td>Host: </td>
	  <td><input type="text" size="30" name="dbhost" value="<?php if (!isset($dbhost)) { echo "localhost"; } else { echo $dbhost; } ?>" />
	</tr>
	<tr>
	  <td>Datenbank: </td>
	  <td><input type="text" size="30" name="dbname" value="<?php if (isset($dbname)) { echo $dbname; } ?>" />
	</tr>
	<tr>
	  <td>User: </td>
	  <td><input type="text" size="30" name="dbuser" value="<?php if (isset($dbuser)) { echo $dbuser; } ?>" />
	</tr>
	<tr>
	  <td>Passwort: </td>
	  <td><input type="password" size="30" name="dbpw" value="<?php if (isset($dbpw)) { echo $dbpw; } ?>" />
	</tr>
	<tr>
	  <td></td>
	  <td><input type="submit" name="submit" value="Weiter" />
	</tr>
      </table></form>


  <?php } ?>

  </fieldset> <?php


}



if (isset($_GET['action']) and $_GET['action'] == "install") {

  $installed = 0;


    if (isset($_POST['submitinstall'])) {

      $connect = mysql_connect($_COOKIE['dbhost'], $_COOKIE['dbuser'], $_COOKIE['dbpw']) or die("Konnte nicht verbinden! Ursache:<br>".mysql_error());
      $selectdb = mysql_selectdb($_COOKIE['dbname']) or die("Konnte Datenbank ".$db." nicht ausw&auml;hlen! Ursache:<br> ".mysql_error());
	
	$pw = $_POST['adminpw'];
	$pw2 = $_POST['adminpw2'];
	$adminpw = md5($pw);
	$adminmail = $_POST['adminmail'];
	$num = $_POST['number'];
	$style = $_POST['style'];
	$time = time();
	if (empty($num)) {
	  $num = "1";
	}

	$file = "inc/gbconfig.php";
	$write = "<?php
// Gaestebuchnummer
\$ibnr = \"".$num."\";
?>
";



        @$handler = fopen($file, r);
        $content = fread($handler, filesize($file));
        @$handlew = fopen($file, w);
	$newcont = $write.$content;
	fwrite($handlew, $newcont);

	if (empty($pw)) {
	  echo "<p class=\"error\">Fehler: Geben Sie bitte Ihr gew&uuml;nschtes Passwort an!</p>";
	} elseif (empty($adminmail)) { 
	  echo "<p class=\"error\">Fehler: Geben Sie bitte Ihre E-Mail Adresse an!</p>";
	} elseif ($pw != $pw2) {
	  echo "<p class=\"error\">Fehler: Die Passw&ouml;rter stimmen nicht &uuml;berein!</p>";
	} else { ?>

	<fieldset>
	  <legend>Installation</legend>

	  <div class="progressbar">
	    <span style="width: 75%;"><strong>75%</strong></span>
	  </div>



	  <p><b>Icybook wird installiert...</b></p><?php

	  $time = time();

	  $sql1 = "CREATE TABLE ib".$num."_entries (
        		ID	INT AUTo_INCREMENT PRIMARY KEY,
			Autor	VARCHAR(30),
			Homepage VARCHAR(40),
			Email	VARCHAR(40),
			Inhalt	TEXT,
			Datum	INT,
			IP	VARCHAR(15),
			Kommentar TEXT,
			Status BooL)";

	  if (mysql_query($sql1)) {
	    echo "<p>Tabelle <i>ib".$num."_entries</i> erfolgreich angelegt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }


	  $sql2 = "CREATE TABLE ib".$num."_settings (
        		titlegb	VARCHAR(50),
			gburl	VARCHAR(100),
			sendmail BooL,
			captcha TINYINT,
			adminmail VARCHAR(40),
			adminpw VARCHAR(50),
			maxchars INT,
			entriespersite tinyint(4),
			passhash VARCHAR(18),
			number INT,
			lang VARCHAR(5),
			installed INT,
			activate BooL,
			lastlogin INT,
			flood BooL,
			floodtime INT,
			mintime BooL,
			hiddenfield BooL,
			bbcode BooL,
			pagemode VARCHAR(7),
			spamfilter TINYINT,
			spamphrases TEXT,
			browsertitle VARCHAR(100),
			smileypos TINYINT,
			smileyrow INT,
			showmails BooL)";

	  if (mysql_query($sql2)) {
	    echo "<p>Tabelle <i>ib".$num."_settings</i> erfolgreich angelegt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }

	  $s = 1;
	  $hash = "";
	  while ($s <= 18) {
	    $digit = rand(0, 9);
	    $hash .= $digit;
	    $s++;
	  }


	  $sql3 = "INSERT INTo ib".$num."_settings (
       		titlegb,
		gburl,
		sendmail,
		captcha,
		adminmail,
		adminpw,
		maxchars,
		entriespersite,
		passhash,
		number,
		lang,
		installed,
		activate,
		lastlogin,
		flood,
		floodtime,
		mintime,
		hiddenfield,
		bbcode,
		pagemode,
		spamfilter,
		spamphrases,
		browsertitle,
		smileypos,
		smileyrow,
		showmails)
	    VALUES (
	      	'Mein G&auml;stebuch',
	        'http://name.server.de/icybook/',
	        '0',
		'1',
	        '$adminmail',
		'$adminpw',
	        '1000',
		'10',
		'$hash',
		'$num',
		'de',
		'$time',
		'0',
		'0',
		'1',
		'3600',
		'1',
		'1',
		'1',
		'modern',
		'1',
		'viagra,porn,cheap,buy,drugs',
		'Mein G&auml;stebuch',
		'2',
		'3',
		'1')";

	  if (mysql_query($sql3)) {
	    echo "<p>Tabelle <i>ib".$num."_settings</i> erfolgreich gef&uuml;llt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }


	  $sql4 = "CREATE TABLE ib".$num."_smileys (
			ID INT AUTo_INCREMENT PRIMARY KEY,
			smileycode VARCHAR(30),
			smileyimg VARCHAR(30))";

	  if (mysql_query($sql4)) {
	    echo "<p>Tabelle <i>ib".$num."_smileys</i> erfolgreich angelegt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }


	  $sql5 = "INSERT INTo ib".$num."_smileys
			(smileycode, smileyimg)
		 VALUES 
			(':-)', 'happy.gif'),
			(':-(', 'sad.gif'),
			(';-)', 'wink.gif'),
			(':-D', 'laugh.gif'),
			(':-P', 'tongue.gif'),
			('8-)', 'cool.gif'),
			(':-o', 'surprise.gif'),
			('%-)', 'crazy.gif'),
			(':-#', 'sick.gif')";

	  if (mysql_query($sql5)) {
	    echo "<p>Tabelle <i>ib".$num."_smileys</i> erfolgreich gef&uuml;llt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }


	  $sql6 = "CREATE TABLE ib".$num."_style (
			bg_all VARCHAR(20),
			fc_all VARCHAR(20),
			lc_all VARCHAR(20),
			fc_ac VARCHAR(20),
			bordercol VARCHAR(20),
			width_all VARCHAR(20),
			bg_hc VARCHAR(20),
			fc_hc VARCHAR(20),
			fs_hc VARCHAR(20),
			ff_hc VARCHAR(20),
			bg_lc VARCHAR(20),
			fc_lc VARCHAR(20),
			fs_lc VARCHAR(20),
			ff_lc VARCHAR(20),
			bg_rc VARCHAR(20),
			fc_rc VARCHAR(20),
			fs_rc VARCHAR(20),
			ff_rc VARCHAR(20),
			header VARCHAR(255),
			css TEXT,
			hover VARCHAR(20),
			entrylinks VARCHAR(20))";

	  if (mysql_query($sql6)) {
	    echo "<p>Tabelle <i>ib".$num."_style</i> erfolgreich angelegt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }

	  if ($style == "1") {
	    $bg_all = "#EDEDED";
	    $fc_all = "#333333";
	    $lc_all = "#104E8B";
	    $fc_ac = "#555555";
	    $width_all = "600";
	    $bg_hc = "#CCCCCC";
	    $fc_hc = "#333333";
	    $fs_hc = "12";
	    $ff_hc = "Verdana";
	    $bg_lc = "#D4D4D4";
	    $fc_lc = "#333333";
	    $fs_lc = "12";
	    $ff_lc = "Verdana";
	    $bg_rc = "#D4D4D4";
	    $fc_rc = "#333333";
	    $fs_rc = "12";
	    $ff_rc = "Verdana";
	    $hover = "#F5F5F5";
	    $entrylinks = "#000080";
	    $bordercol = "#B0B0B0";
	    $css = "";
	  } elseif ($style == "2") {
	    $bg_all = "#FFFFFF";
	    $fc_all = "#222222";
	    $lc_all = "#30BBEB";
	    $fc_ac = "#30BBEB";
	    $width_all = "600";
	    $bg_hc = "#30BBEB";
	    $fc_hc = "#FFFFFF";
	    $fs_hc = "9";
	    $ff_hc = "Verdana";
	    $bg_lc = "#30BBEB";
	    $fc_lc = "#FFFFFF";
	    $fs_lc = "11";
	    $ff_lc = "Verdana";
	    $bg_rc = "#FFFFFF";
	    $fc_rc = "#222222";
	    $fs_rc = "11";
	    $ff_rc = "Verdana";
	    $hover = "#D1F6FF";
	    $entrylinks = "#30BBEB";
	    $bordercol = "#FFFFFF";
	    $css = "#icybook .newleft a:link, #icybook .newleft a:visited {\n  color: #FFFFFF;\n  text-decoration: underline;\n}";
	  } elseif ($style == "3") {
	    $bg_all = "#000000";
	    $fc_all = "#EDEDED";
	    $lc_all = "#EDEDED";
	    $fc_ac = "#CBCBCB";
	    $width_all = "600";
	    $bg_hc = "#000000";
	    $fc_hc = "#EDEDED";
	    $fs_hc = "11";
	    $ff_hc = "Verdana";
	    $bg_lc = "#000000";
	    $fc_lc = "#EDEDED";
	    $fs_lc = "12";
	    $ff_lc = "Verdana";
	    $bg_rc = "#000000";
	    $fc_rc = "#EDEDED";
	    $fs_rc = "12";
	    $ff_rc = "Verdana";
	    $hover = "#EDEDED";
	    $entrylinks = "#CBCBCB";
	    $bordercol = "#000000";
	    $css = "#icybook .entry {\n  border-top: 2px solid #EDEDED;\n  margin-bottom: 50px;\n}";
	  }


	  $sql7 = "INSERT INTo ib".$num."_style (
			bg_all,
			fc_all,
			lc_all,
			fc_ac,
			width_all,
			bg_hc,
			fc_hc,
			fs_hc,
			ff_hc,
			bg_lc,
			fc_lc,
			fs_lc,
			ff_lc,
			bg_rc,
			fc_rc,
			fs_rc,
			ff_rc,
			hover,
			entrylinks,
			bordercol,
			css)
		 VALUES (
			'$bg_all',
			'$fc_all',
			'$lc_all',
			'$fc_ac',
			'$width_all',
			'$bg_hc',
			'$fc_hc',
			'$fs_hc',
			'$ff_hc',
			'$bg_lc',
			'$fc_lc',
			'$fs_lc',
			'$ff_lc',
			'$bg_rc',
			'$fc_rc',
			'$fs_rc',
			'$ff_rc',
			'$hover',
			'$entrylinks',
			'$bordercol',
			'$css')";

	  if (mysql_query($sql7)) {
	    echo "<p>Tabelle <i>ib".$num."_style</i> erfolgreich gef&uuml;llt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }


	  $sql8 = "CREATE TABLE ib".$num."_badwords (
			ID	INT AUTo_INCREMENT PRIMARY KEY,
			Badword VARCHAR(30),
			Ersatz	VARCHAR(30))";

	  if (mysql_query($sql8)) {
	    echo "<p>Tabelle <i>ib".$num."_badwords</i> erfolgreich angelegt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }


	  $sql9 = "INSERT INTo ib".$num."_badwords (
			Badword,
			Ersatz)
		 VALUES (
			'Arschloch',
			'*********')";

	  if (mysql_query($sql9)) {
	    echo "<p>Tabelle <i>ib".$num."_badwords</i> erfolgreich gef&uuml;llt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }


	  $sql10 = "INSERT INTo ib".$num."_entries (
			Autor,
			Homepage,
			Email,
			Inhalt,
			Datum,
			IP,
			Status)
		 VALUES (
			'Icybook',
			'http://icybook.de',
			'icybook@web.de',
			'Herzlichen Gl&uuml;ckwunsch zur Installation des Icybooks!<br />Bitte loggen Sie sich zur Anpassung des G&auml;stebuchs ein. Dort k&ouml;nnen Sie unter anderem auch diesen Eintrag l&ouml;schen.<br /><br />Viel Spa&szlig; bei der weiteren Benutzung!',
			'$time',
			'-',
			'1')";

	  if (mysql_query($sql10)) {
	    echo "<p>Testeintrag erfolgreich angelegt!</p>";
	  } else {
	    die("Installation abgebrochen. Grund: ".mysql_error());
	  }

	  $installed = 1;

	  echo "<br /><p>&raquo; <a href=\"install.php?action=complete\" title=\"Installation abschlie&szlig;en\">Installation abschlie&szlig;en</a></p></fieldset>";

  
    }
 
  } ?>


  <?php if ($installed != 1) { ?>

    <fieldset>
      <legend>Admin-Konto</legend>

    <div class="progressbar">
      <span style="width: 50%;"><strong>50%</strong></span>
    </div>

    <p>Geben Sie bitte Ihre E-Mail, Ihr gew&uuml;nschtes Passwort f&uuml;r das Admin-Center sowie die Nummer des G&auml;stebuchs (bei Erstinstallation &quot;1&quot;) ein und klicken Sie auf &quot;Installieren&quot;.</p>
    
    <form action="install.php?action=install&step=install" method="post">
    <table>
      <tr>
	<td>E-Mail: </td>
	<td><input type="text" name="adminmail" size="30" value="<?php if (isset($_POST['adminmail'])) { echo $_POST['adminmail']; } ?>" /></td>
      </tr>
      <tr>
	<td>Passwort: </td>
	<td><input type="password" name="adminpw" size="30" /></td>
      </tr>
      <tr>
	<td>Passwort wiederholen: </td>
	<td><input type="password" name="adminpw2" size="30" /></td>
      </tr>
      <tr>
	<td>Nummer des G&auml;stebuchs: </td>
	<td><input type="text" name="number" size="30" value="<?php if (!isset($_POST['number'])) { echo "1"; } else { echo $_POST['number']; } ?>" /></td>
      </tr>
      <tr>
	<td>Design ausw&auml;hlen:
	    <p style="font-size: 11px;">Sie k&ouml;nnen das Design jederzeit im<br />Admin-Men&uuml; &auml;ndern.</p></td>
	<td style>
	    <p style="float: left;"><img src="images/styles/classic_noble.png" /><br /><input type="radio" name="style" value="1" <?php if (!isset($_POST['style']) or $_POST['style'] == "1") { echo "checked=\"checked\""; } ?> /> Classic Noble</p>
	    <p style="float: left; margin-left: 50px;"><img src="images/styles/fresh_blue.png" /><br /><input type="radio" name="style" value="2" <?php if (isset($_POST['style']) and $_POST['style'] == "2") { echo "checked=\"checked\""; } ?> /> Fresh Blue</p>
	    <p style="float: left; margin-left: 50px;"><img src="images/styles/ultra_black.png" /><br /><input type="radio" name="style" value="3" <?php if (isset($_POST['style']) and $_POST['style'] == "3") { echo "checked=\"checked\""; } ?> /> Ultra Black</p></td>
      </tr>
      <tr>
	<td></td>
	<td><input type="submit" value="Installieren" name ="submitinstall" /></td>
      </tr>
    </table>
    </form>

  </fieldset>

  <?php  }

}

if (isset($_GET['action']) and $_GET['action'] == "complete") { ?>

<fieldset>
  <legend>Abschluss</legend>

  <div class="progressbar">
    <span style="width: 100%;"><strong>100%</strong></span>
  </div>

  <p>Das Icybook wurde erfolgreich installiert. L&ouml;schen Sie aus Sicherheitsgr&uuml;nden bitte die install.php, damit sie niemand anderes erneut ausf&uuml;hren kann.<br /><br />
     Sie k&ouml;nnen sich nun in das Admin-Men&uuml; einloggen und das Icybook dort anpassen. F&uuml;r Fragen rund um das G&auml;stebuch benutzen Sie bitte die Support-Funktion im Admin-Men&uuml; oder besuchen uns auf Facebook: <a href="http://www.facebook.com/icybook" target="blank" title="Facebook">www.facebook.com/icybook</a><br /><br />
     &raquo; <a href="index.php" title="G&auml;stebuch">Weiter zum G&auml;stebuch</a></p>

</fieldset>

<?php } ?>

</body>
</html>