<?php
session_start();
include("inc/gbconfig.php");
$version = "1.73";
include("inc/functions.php");
get_timezone();
$settings = get_settings($ibnr);
extract($settings);
include("inc/lang/".$lang.".php");

$section = get_section();


if (isset($_SESSION['admin']) and $_SESSION['admin'] == 1) {

  if ($section == "logout") {
    @session_destroy();
    @header("Location: ".$gburl);
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=".$gburl."\" />";
  }

?>



<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>
<title>Icybook Admin-Center</title>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" />
<script src="inc/javascript.js" type="text/javascript"></script>
<style type="text/css">
  <?php include("inc/style.php"); ?>
</style>
</head>

<body style="background-color: #EDEDED;">

<div id="adminbox">

<div id="adminnavi"><br />

  <span><a href="admin.php?section=start">&nbsp;<?php echo $adm_navi_overview; ?>&nbsp;</a></span> |
  <span><a href="admin.php?section=settings">&nbsp;<?php echo $adm_navi_settings; ?>&nbsp;</a> </span> |
  <span><a href="admin.php?section=security">&nbsp;<?php echo $adm_navi_security; ?>&nbsp;</a> </span> |
  <span><a href="admin.php?section=showentries">&nbsp;<?php echo $adm_navi_entries; ?>&nbsp;</a> </span> |
  <span><a href="admin.php?section=style">&nbsp;<?php echo $adm_navi_style; ?> </a>&nbsp;</span> |
  <span><a href="admin.php?section=smileys">&nbsp;Smileys&nbsp;</a></span> |
  <span><a href="admin.php?section=badwords">&nbsp;Badwords&nbsp;</a></span>

</div>


<div id="adminmain">

<?php




// bersicht
  
if ($section == "start") { 

  $sqlsettings = "SELECT installed, activate FROM ".$pre."settings";
  $settings = mysql_fetch_assoc(mysql_query($sqlsettings));

  $sqlentries = "SELECT ID FROM ".$pre."entries";
  $entries = mysql_num_rows(mysql_query($sqlentries));

  $sqlentries2 = "SELECT ID FROM ".$pre."entries WHERE Status = '0'";
  $entries2 = mysql_num_rows(mysql_query($sqlentries2));

  $lastlogin = $_SESSION['lastlogin'];

?>

<table>
  <tr>
    <th colspan="2"><?php echo $adm_navi_overview; ?></th>
  </tr>
  <tr>
    <td><?php echo $adm_operating; ?>:</th>
    <td><?php echo date("d.m.Y - H:i", $settings['installed']); ?></td>
  <tr>
    <td><?php echo $adm_version; ?>:</th>
    <td><?php echo $version; ?> (<a href="http://icybook.de/index.php?site=versioncheck&lang=<?php echo $lang; ?>&vers=<?php echo $version; ?>" target="_blank"><?php echo $adm_navi_version; ?></a>)</td>
  </tr>
  <tr>
    <td><?php echo $adm_lastlogin; ?>:</th>
    <td><?php if ($lastlogin == "0") { echo $adm_firstvisit; } else { echo date("d.m.Y - H:i", $lastlogin); } ?></td>
  </tr>
  <tr>
    <td><?php echo $adm_allentries; ?>:</th>
    <td><?php echo $entries; ?></td>
  </tr>
  <tr>
    <td><?php echo $adm_inactive; ?>:</th>
    <td><?php echo $entries2; ?></td>
  </tr>
</table><?php }




// Allgemeine Einstellungen

if ($section == "settings") {

  if (isset($_POST['submit'])) {

    echo "<p>".$adm_save."</p>";

    $up_titlegb = mysql_real_escape_string(strip_tags($_POST['up_titlegb']));
    $up_gburl = mysql_real_escape_string(strip_tags($_POST['up_gburl']));
    $up_eps = mysql_real_escape_string(strip_tags($_POST['up_eps']));
    $up_maxchars = mysql_real_escape_string(strip_tags($_POST['up_maxchars']));
    $up_sendmail = mysql_real_escape_string(strip_tags($_POST['up_sendmail']));
    $up_adminmail = mysql_real_escape_string(strip_tags($_POST['up_adminmail']));
    $up_lang = mysql_real_escape_string(strip_tags($_POST['up_lang']));
    $up_bbcode = mysql_real_escape_string(strip_tags($_POST['up_bbcode']));
    $up_pagemode = mysql_real_escape_string(strip_tags($_POST['up_pagemode']));
    $up_browsertitle = mysql_real_escape_string(strip_tags($_POST['up_browsertitle']));
    $up_showmails = mysql_real_escape_string(strip_tags($_POST['up_showmails']));


    $sql = "UPDATE 
		".$pre."settings
	    SET
		titlegb = '$up_titlegb',
		gburl = '$up_gburl',
		entriespersite = '$up_eps',
		maxchars = '$up_maxchars',
		sendmail = '$up_sendmail',
		adminmail = '$up_adminmail',
		lang = '$up_lang',
		bbcode = '$up_bbcode',
		pagemode = '$up_pagemode',
		browsertitle = '$up_browsertitle',
		showmails = '$up_showmails'";

    mysql_query($sql);
    
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=settings\">";

  } ?>

  <table><form action="admin.php?section=settings" method="post">
    <tr>
      <th colspan="2"><?php echo $adm_globalset; ?></th>
    </tr>
    <tr>
      <td><?php echo $adm_mail; ?>:</td>
      <td><input type="text" name="up_adminmail" size="30" value="<?php echo $adminmail; ?>" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_pw; ?>:</td>
      <td><a href="admin.php?section=pwchange"><?php echo $adm_change; ?></a></td>
    </tr>
    <tr>
      <td><?php echo $adm_url; ?>:</td>
      <td><input type="text" name="up_gburl" size="30" value="<?php echo $gburl; ?>" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_lang; ?>:</td>
      <td><select name="up_lang" style="width: 200px;">
	    <option <?php if($lang == "de") echo "selected"; ?> value="de"><?php echo $adm_de; ?></option>
	    <option <?php if($lang == "en") echo "selected"; ?> value="en"><?php echo $adm_en; ?></option>
	    <option <?php if($lang == "fr") echo "selected"; ?> value="fr"><?php echo $adm_fr; ?></option>
	  </select></td>
    </tr>
    <tr>
      <th colspan="2"><?php echo $adm_output; ?></th>
    </tr>
    <tr>
      <td width="200px"><?php echo $adm_browsertitle; ?>:</td>
      <td width="300px"><input type="text" name="up_browsertitle" size="30" value="<?php echo $browsertitle; ?>" /></td>
    </tr>
    <tr>
      <td width="200px"><?php echo $adm_title; ?>:</td>
      <td width="300px"><input type="text" name="up_titlegb" size="30" value="<?php echo $titlegb; ?>" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_eps; ?>:</td>
      <td><input type="text" name="up_eps" size="30" value="<?php echo $eps; ?>" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_pagemode; ?></td>
      <td><input type="radio" name="up_pagemode" value="classic"
	    <?php if ($pagemode == "classic") echo "checked"; ?>>
	    <?php echo $adm_classic; ?> <input type="radio" name="up_pagemode" value="modern"
	    <?php if ($pagemode == "modern") echo "checked"; ?>>
	    <?php echo $adm_modern; ?></td>
    </tr>
    <tr>
      <th colspan="2"><?php echo $adm_functions; ?></th>
    </tr>
    <tr>
      <td><?php echo $adm_limit; ?>:</td>
      <td><input type="text" name="up_maxchars" size="30" value="<?php echo $maxchars; ?>" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_act_mail; ?></td>
      <td><input type="radio" name="up_sendmail" value="1"
	    <?php if ($sendmail == "1") echo "checked"; ?>>
	    <?php echo $adm_yes; ?> <input type="radio" name="up_sendmail" value="0"
	    <?php if ($sendmail == "0") echo "checked"; ?>>
	    <?php echo $adm_no; ?></td>
    </tr>
    <tr>
      <td><?php echo $adm_bbcode; ?></td>
      <td><input type="radio" name="up_bbcode" value="1"
	    <?php if ($bbcode == "1") echo "checked"; ?>>
	    <?php echo $adm_yes; ?> <input type="radio" name="up_bbcode" value="0"
	    <?php if ($bbcode == "0") echo "checked"; ?>>
	    <?php echo $adm_no; ?></td>
    </tr>
    <tr>
      <td><?php echo $adm_showmails; ?></td>
      <td><input type="radio" name="up_showmails" value="1"
	    <?php if ($showmails == "1") echo "checked"; ?>>
	    <?php echo $adm_yes; ?> <input type="radio" name="up_showmails" value="0"
	    <?php if ($showmails == "0") echo "checked"; ?>>
	    <?php echo $adm_no; ?></td>
    </tr>
    <tr>
      <th colspan="2"><input type="submit" value="<?php echo $buttonsend; ?>" name="submit" /></th>
    </tr>
  </form></table>
	
<?php }




// Passwort wechseln

if ($section == "pwchange") { 

  if (isset($_POST['submit'])) {

    $oldpw = $_POST['oldpw'];
    $newpw = $_POST['newpw'];
    $newpw2 = $_POST['newpw2'];
    $md5pw = md5($newpw);

    $sql = "SELECT adminpw FROM ".$pre."settings";
    $result = mysql_query($sql);
    $row = mysql_fetch_assoc($result);

    if (md5($oldpw) != $row['adminpw']) {
      echo "<p><b>".$error.":</b> ".$adm_err_oldpw."</p>";
    } elseif ($newpw != $newpw2) {
      echo "<p><b>".$error.":</b> ".$adm_err_oldnew."</p>";
    } else {
      $sql = "UPDATE ".$pre."settings SET adminpw = '$md5pw'";
      mysql_query($sql);
      echo "<p>".$adm_pwchanged."!</p>";
      echo "<meta http-equiv=\"refresh\" content=\"2; URL=admin.php?section=settings\">";
    }

  } ?>


  <table><form method="post" action="admin.php?section=pwchange">
    <tr>
      <th colspan="2"><?php echo $adm_changepw; ?></td>
    </tr>
    <tr>
      <td><?php echo $adm_oldpw; ?>:</td>
      <td><input type="password" name="oldpw" size="30" />
    </tr>
    <tr>
      <td><?php echo $adm_newpw; ?>:</td>
      <td><input type="password" name="newpw" size="30" />
    </tr>
    <tr>
      <td><?php echo $adm_newpw2; ?>:</td>
      <td><input type="password" name="newpw2" size="30" />
    </tr>
    <tr>
      <th colspan="2"><input type="submit" value="<?php echo $buttonsend; ?>" name="submit" /> </th>
    </tr>
  </form></table>

<?php }




// Sicherheit

if ($section == "security") {

  if (isset($_POST['submit'])) {

    echo "<p>".$adm_save."</p>";

    $up_captcha = (int)$_POST['up_captcha'];
    $up_floodtime = (int)$_POST['up_floodtime'];
    $up_mintime = (int)$_POST['up_mintime'];
    $up_hiddenfield = (int)$_POST['up_hiddenfield'];
    $up_activate = (int)$_POST['up_activate'];
    $up_spamfilter = (int)$_POST['up_spamfilter'];
    $up_flood = (int)$_POST['up_flood'];
    $up_spamphrases = mysql_real_escape_string(strip_tags($_POST['up_spamphrases']));


    $sql = "UPDATE ".$pre."settings SET
		captcha = '$up_captcha',
		flood = '$up_flood',
		floodtime = '$up_floodtime',
		mintime = '$up_mintime',
		hiddenfield = '$up_hiddenfield',
		activate = '$up_activate',
		spamfilter = '$up_spamfilter',
		spamphrases = '$up_spamphrases'";

    mysql_query($sql) or die();
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=security\">";

  }


  echo "<form method=\"post\" action=\"admin.php?section=security\"><table>
	  <tr>
	    <th colspan=\"2\">".$ind_captcha."</th>
	  </tr>
	  <tr>
	    <td style=\"width: 200px;\">".$adm_act_captcha."</td>
	    <td><input type=\"radio\" name=\"up_captcha\" value=\"1\" ";
      	        if ($captcha == "1") { echo "checked"; } echo " />".$adm_captcha."
		<input type=\"radio\" name=\"up_captcha\" value=\"2\" "; 
                if ($captcha == "2") { echo "checked"; } echo " />".$adm_calc."
		<input type=\"radio\" name=\"up_captcha\" value=\"3\" "; 
                if ($captcha == "3") { echo "checked"; } echo " />".$adm_quest."<br />
		<input type=\"radio\" name=\"up_captcha\" value=\"0\" "; 
                if ($captcha == "0") { echo "checked"; } echo " />".$adm_off."
	    </td>
	  </tr>
	  <tr>
	    <th colspan=\"2\">".$adm_flood."</th>
	  </tr>
	  <tr>
	    <td>".$adm_flood."</td>
	    <td><input type=\"radio\" name=\"up_flood\" value=\"1\" ";
      	        if ($flood == "1") { echo "checked"; } echo " />".$adm_yes."
		<input type=\"radio\" name=\"up_flood\" value=\"0\" "; 
                if ($flood == "0") { echo "checked"; } echo " />".$adm_no."
	    </td>
	  <tr>
	    <td>".$adm_floodtime."</td>
	    <td><input type=\"text\" name=\"up_floodtime\" value=\"".$floodtime."\" /></td>
	  </tr>
	  </tr>
	  <tr>
	    <th colspan=\"2\">".$adm_spamfilter."</th>
	  </tr>
	  <tr>
	    <td>".$adm_spamentries."</td>
	    <td><input type=\"radio\" name=\"up_spamfilter\" value=\"2\" ";
      	        if ($spamfilter == "2") { echo "checked"; } echo " />".$adm_directdel."
		<input type=\"radio\" name=\"up_spamfilter\" value=\"1\" "; 
                if ($spamfilter == "1") { echo "checked"; } echo " />".$adm_spaminact."<br />
		<input type=\"radio\" name=\"up_spamfilter\" value=\"0\" ";
      	        if ($spamfilter == "0") { echo "checked"; } echo " />".$adm_nofilter."
	    </td>
	  </tr>
	  <tr>
	    <td>".$adm_spamphrases."</td>
	    <td><textarea name=\"up_spamphrases\" cols=\"35\" rows=\"5\" id=\"spamphrases\">".$spamphrases."</textarea>
	  </tr>
	  <tr>
	    <th colspan=\"2\">".$adm_misc."</th>
	  </tr>
	  <tr>
	    <td>".$adm_timeprot." *</td>
	    <td><input type=\"radio\" name=\"up_mintime\" value=\"1\" ";
      	        if ($mintime == "1") { echo "checked"; } echo " />".$adm_yes."
		<input type=\"radio\" name=\"up_mintime\" value=\"0\" "; 
                if ($mintime == "0") { echo "checked"; } echo " />".$adm_no."
	    </td>
	  </tr>
	  <tr>
	    <td>".$adm_enablenew."</td>
	    <td><input type=\"radio\" name=\"up_activate\" value=\"1\" ";
      	        if ($activate == "1") { echo "checked"; } echo " />".$adm_yes."
		<input type=\"radio\" name=\"up_activate\" value=\"0\" "; 
                if ($activate == "0") { echo "checked"; } echo " />".$adm_no."
	    </td>
	  </tr>
	  <tr>
	    <td>".$adm_hidden." **</td>
	    <td><input type=\"radio\" name=\"up_hiddenfield\" value=\"1\" ";
      	        if ($hiddenfield == "1") { echo "checked"; } echo " />".$adm_yes."
		<input type=\"radio\" name=\"up_hiddenfield\" value=\"0\" "; 
                if ($hiddenfield == "0") { echo "checked"; } echo " />".$adm_no."
	    </td>
	  </tr>
	  <tr>
	    <th colspan=\"2\"><input type=\"submit\" value=\"".$buttonsend."\" name=\"submit\" /></th>
	  </tr>
	</table></form>

	<p style=\"font-size: 11px; \">* ".$adm_info_time."</p>
	<p style=\"font-size: 11px; \">** ".$adm_info_hidden."</p>";

}




// Eintrge anzeigen

if ($section == "showentries") {

  if (!isset($_GET['page'])) {
    $page = 1;
  } else {
    $page = (int)$_GET['page'];
  }

  $page2 = ($page-1)*$eps;

  $sql = "SELECT * FROM ".$pre."entries ORDER BY ID DESC LIMIT $page2, $eps";
  $result = mysql_query($sql);
  
  if(!mysql_num_rows($result)) {
    echo "<p>".$noentries."</p>";
  } else {

    $smileysql = "SELECT * FROM ".$pre."smileys";
    $smileyresult = mysql_query($smileysql); ?>

    <form method="post" action="admin.php?section=multi">
    <table>
      <tr>
	<th width="10px">&nbsp;</td>
        <th width="80px"><?php echo $adm_time; ?></th>
        <th width="150px"><?php echo $adm_author; ?></th>
        <th width="270px"><?php echo $adm_entry; ?></th>
        <th width="50px"><?php echo $adm_actions; ?></th>
	<th width="50px"><?php echo $adm_status; ?></th>
      </tr> <?php

      while ($row = mysql_fetch_assoc($result)) { ?>

	<tr>
	  <td><input type="checkbox" name="who[]" value="<?php echo $row['ID']; ?>" />
	  <td><?php echo date("d.m.Y", $row['Datum']); ?><br /><?php echo date("h:i:s", $row['Datum']); ?></td>
	  <td><?php echo $row['Autor']; ?><br /><font size="2">(<?php echo $row['IP']; ?>)</font></td>
	  <td><?php echo breakLongWords($row['Inhalt'], 20, " "); ?></td>
	  <td style="text-align: center;">
	    <a href="admin.php?section=edit&id=<?php echo $row['ID']; ?>"><img src="images/edit.gif" alt="<?php echo $adm_edit; ?>" title="<?php echo $adm_edit; ?>" /></a> 
	    <a href="admin.php?section=reallydelete&id=<?php echo $row['ID']; ?>"><img src="images/delete.gif" alt="<?php echo $adm_delete; ?>" title="<?php echo $adm_delete; ?>" /></a> 
	    <a href="admin.php?section=comment&id=<?php echo $row['ID']; ?>"><img src="images/comment.gif" alt="<?php echo $adm_comment; ?>" title="<?php echo $adm_comment; ?>" /></a></td>
	  <td style="text-align: center;"><?php if ($row['Status'] == "1") { ?>
	      <a href="admin.php?section=entry_status&do=0&id=<?php echo $row['ID']; ?>"><img src="images/enable.gif" alt="" /><?php
	    } else { ?>
	      <a href="admin.php?section=entry_status&do=1&id=<?php echo $row['ID']; ?>"><img src="images/disable.gif" alt="" /><?php
	    } ?></td>
	</tr>
      <?php } ?>

      <tr>
	<th><input type="checkbox" name="selectall" onclick="javascript:checkall();" /></th>
	<th colspan="5"><?php echo $adm_selected; ?>:
	  <select name="what">
	    <option value="delete"><?php echo ucfirst($adm_delete); ?></option>
	    <option value="1"><?php echo $adm_enable; ?></option>
	    <option value="0"><?php echo $adm_disable; ?></option>
	  </select>
	  <input type="submit" value="<?php echo $buttonsend; ?>" name="multisubmit" /></th>
      </tr>
    </table></form><br />
		
    <?php
    // Anzeige der Seiten
    $select = "select ID from ".$pre."entries";
    $result = mysql_query($select);
    $anzahl = mysql_num_rows($result);
    $seiten = ceil($anzahl/$eps);
		
    echo show_pages($pagemode, "admin.php?section=showentries&", $page, $seiten);
    
  }
    
}




// Eintrag kommentieren

if ($section == "comment") {

  if (isset($_POST['submit'])) {

    $id = (int)$_GET['id'];
    $comment = mysql_real_escape_string(strip_tags($_POST['content']));

    $sql = "SELECT * FROM ".$pre."entries where ID = '$id'";
    $result = mysql_query($sql);
    $row = mysql_fetch_assoc($result);

    $commentadd = "UPDATE ".$pre."entries SET Kommentar = '$comment' WHERE ID ='$id'";
    mysql_query($commentadd);
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=showentries\">";

  }

  $id = (int)$_GET['id'];

  $sql = "SELECT * FROM ".$pre."entries where ID = '$id'";
  $result = mysql_query($sql);
  $row = mysql_fetch_assoc($result);

  echo "<table><form action=\"admin.php?section=comment&id=".$id."\" method=\"post\">";
  echo   "<tr><th>".$adm_comment_head." ".$row['Autor']." (".date("d.m.Y, h:i:s", $row['Datum']).") ".$adm_comment_head2."</th></tr>";
  echo   "<tr><th><textarea name=\"content\" cols=\"35\" rows=\"6\">"; if ($row['Kommentar'] != "") echo $row['Kommentar']; echo "</textarea></th></tr>";
  echo   "<tr><th><input type=\"submit\" value=\"".$buttonsend."\" name=\"submit\" /></th></tr>";
  echo "</form></table>";

}




// Eintrag lschen
if ($section == "reallydelete") {

  $id = (int)$_GET['id'];

  $sql = "SELECT Autor, Datum FROM ".$pre."entries WHERE ID = '$id'";
  $del = mysql_fetch_assoc(mysql_query($sql));

  echo "<p>".$adm_entry_del1." ".$del['Autor']." (".date("d.m.Y - H:i", $del['Datum']).") ".$adm_entry_del2."<br /><br />
	  <form method=\"post\" action=\"admin.php?section=delete&id=".$id."\"><input type=\"submit\" value=\"".$adm_yes."\" /></form>
	  <form method=\"post\" action=\"admin.php?section=showentries\"><input type=\"submit\" value=\"".$adm_no."\" /></form>
	</p>";
}



// Eintrag lschen
if ($section == "delete") {

  echo "<p>".$adm_save."</p>";

  $id = (int)$_GET['id'];

  $sql = "DELETE FROM ".$pre."entries WHERE ID = '$id'";
  mysql_query($sql);
    
  echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=showentries\">";

}



// Eintrag Status ndern
if ($section == "entry_status") {

  echo "<p>".$adm_save."</p>";

  $id = (int)$_GET['id'];
  $status = (int)$_GET['do'];
  $sql = "UPDATE ".$pre."entries SET Status = '$status' WHERE ID = '$id'";
  mysql_query($sql);

  echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=showentries\">";

}



// Eintrag editieren

if ($section == "edit") {

  if (isset($_POST['submit'])) {

    echo "<p>".$adm_save."</p>";

    $id = (int)$_GET['id'];
    $autor = mysql_real_escape_string(strip_tags($_POST['autor']));
    $email = mysql_real_escape_string(strip_tags($_POST['email']));
    $homepage = mysql_real_escape_string(strip_tags($_POST['homepage']));
    $inhalt = nl2br(mysql_real_escape_string(strip_tags($_POST['inhalt'])));

    $sql = "UPDATE ".$pre."entries SET
		Autor = '$autor',
		Email = '$email',
		Homepage = '$homepage',
		Inhalt = '$inhalt'
	    WHERE
		ID = '$id'";

    mysql_query($sql) or die();
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=showentries\">";

  }

  $id = (int)$_GET['id'];
  $sql = "SELECT * FROM ".$pre."entries WHERE ID = '$id'";
  $entry = mysql_fetch_assoc(mysql_query($sql));
  $inhalt = str_replace("<br />", "", $entry['Inhalt']); ?>

  <form method="post" action="admin.php?section=edit&amp;id=<?php echo $id; ?>">
  <table>
    <tr>
      <th colspan="2">Eintrag bearbeiten</th>
    </tr>
    <tr>
      <td><?php echo $ind_name; ?></td>
      <td><input type="text" name="autor" value="<?php echo $entry['Autor']; ?>" size="30" /></td>
    </tr>
    <tr>
      <td>Email:</td>
      <td><input type="text" name="email" value="<?php echo $entry['Email']; ?>" size="30" /></td>
    </tr>
    <tr>
      <td>Homepage:</td>
      <td><input type="text" name="homepage" value="<?php echo $entry['Homepage']; ?>" size="30" /></td>
    </tr>
    <tr>
      <td><?php echo $ind_content; ?></td>
      <td><textarea rows="6" cols="35" name="inhalt"><?php echo $inhalt; ?></textarea></td>
    </tr>
    <tr>
      <th colspan="2"><input type="submit" name="submit" value="<?php echo $buttonsend; ?>" /></th>
    </tr>
  </table>
  </form><?php

}



// Massenbearbeitung
if ($section == "multi") {

  if ($_POST['what'] == "0" or $_POST['what'] == "1") {
    $what = $_POST['who'];
    echo "<p>Eintr&auml;ge werden de-/aktiviert...</p>";
    foreach ($what as $id) {
      $sql = "UPDATE ".$pre."entries SET Status = '$what' WHERE ID = '$id'";
      mysql_query($sql);
    }
  }

  if ($_POST['what'] == "delete") {
    echo "<p>Eintr&auml;ge werden gel&ouml;scht...</p>";
    $what = $_POST['who'];
    foreach ($what as $id) {
      $sql = "DELETE FROM ".$pre."entries WHERE ID = '$id'";
      mysql_query($sql) or die();
    }
  }

  echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=showentries\">";

}

  

// Style
if ($section == "style") {

  if (isset($_POST['submit'])) {

    echo "<p>".$adm_save."</p>";
    $header = mysql_real_escape_string(strip_tags($_POST['header']));
    $bg_all = mysql_real_escape_string(strip_tags($_POST['bg_all']));
    $fc_all = mysql_real_escape_string(strip_tags($_POST['fc_all']));
    $lc_all = mysql_real_escape_string(strip_tags($_POST['lc_all']));
    $fc_ac = mysql_real_escape_string(strip_tags($_POST['fc_ac']));
    $width_all = mysql_real_escape_string(strip_tags($_POST['width_all']));
    $bg_hc = mysql_real_escape_string(strip_tags($_POST['bg_hc']));
    $fc_hc = mysql_real_escape_string(strip_tags($_POST['fc_hc']));
    $fs_hc = mysql_real_escape_string(strip_tags($_POST['fs_hc']));
    $ff_hc = mysql_real_escape_string(strip_tags($_POST['ff_hc']));
    $bg_lc = mysql_real_escape_string(strip_tags($_POST['bg_lc']));
    $fc_lc = mysql_real_escape_string(strip_tags($_POST['fc_lc']));
    $fs_lc = mysql_real_escape_string(strip_tags($_POST['fs_lc']));
    $ff_lc = mysql_real_escape_string(strip_tags($_POST['ff_lc']));
    $bg_rc = mysql_real_escape_string(strip_tags($_POST['bg_rc']));
    $fc_rc = mysql_real_escape_string(strip_tags($_POST['fc_rc']));
    $fs_rc = mysql_real_escape_string(strip_tags($_POST['fs_rc']));
    $ff_rc = mysql_real_escape_string(strip_tags($_POST['ff_rc']));
    $css = mysql_real_escape_string(strip_tags($_POST['css']));
    $entrylinks = mysql_real_escape_string(strip_tags($_POST['entrylinks']));
    $hover = mysql_real_escape_string(strip_tags($_POST['hover']));
    $bordercol = mysql_real_escape_string(strip_tags($_POST['bordercol']));

    $sql = "UPDATE
		".$pre."style
	    SET
		header = '$header',
		bg_all = '$bg_all',
		fc_all = '$fc_all',
		lc_all = '$lc_all',
		fc_ac = '$fc_ac',
		width_all = '$width_all',
		bg_hc = '$bg_hc',
		fc_hc = '$fc_hc',
		fs_hc = '$fs_hc',
		ff_hc = '$ff_hc',
		bg_lc = '$bg_lc',
		fc_lc = '$fc_lc',
		fs_lc = '$fs_lc',
		ff_lc = '$ff_lc',
		bg_rc = '$bg_rc',
		fc_rc = '$fc_rc',
		fs_rc = '$fs_rc',
		ff_rc = '$ff_rc',
		css = '$css',
		entrylinks = '$entrylinks',
		hover = '$hover',
		bordercol = '$bordercol'";

    mysql_query($sql);
    
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=style\">";

  }

  $sql = "SELECT * FROM ".$pre."style";
  $query = mysql_query($sql);
  $row = mysql_fetch_assoc($query); 

  ?>

  <form method="post" action="admin.php?section=style">
  <table>
    <tr>
      <th colspan="2"><?php echo $adm_general; ?></th>
    </tr>
    <tr>
      <td><?php echo $adm_entrywidth; ?> <span style="font-size: 11px;">(<?php echo $adm_recom; ?>: 500 - 800)</span></td>
      <td><input type="text" size="15" name="width_all" value="<?php echo $row['width_all']; ?>" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_header; ?> (URL)</td>
      <td><input type="text" size="15" name="header" value="<?php echo $row['header']; ?>" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_bgcolor; ?></td>
      <td><input type="text" size="15" name="bg_all" maxlength="7" value="<?php echo $row['bg_all']; ?>" class="colorpicker" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_genfont; ?></td>
      <td><input type="text" size="15" name="fc_all" maxlength="7" value="<?php echo $row['fc_all']; ?>" class="colorpicker" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_linkcolor; ?></td>
      <td><input type="text" size="15" name="lc_all" maxlength="7" value="<?php echo $row['lc_all']; ?>" class="colorpicker" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_comcol; ?></td>
      <td><input type="text" size="15" name="fc_ac" maxlength="7" value="<?php echo $row['fc_ac']; ?>" class="colorpicker" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_entrylinks; ?></td>
      <td><input type="text" size="15" name="entrylinks" maxlength="7" value="<?php echo $row['entrylinks']; ?>" class="colorpicker" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_hover; ?></td>
      <td><input type="text" size="15" name="hover" maxlength="7" value="<?php echo $row['hover']; ?>" class="colorpicker" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_bordercol; ?></td>
      <td><input type="text" size="15" name="bordercol" maxlength="7" value="<?php echo $row['bordercol']; ?>" class="colorpicker" /></td>
    </tr>
  </table>


  <table>
    <tr>
      <th colspan="6"><?php echo $adm_tablehead; ?></th>
    </tr>
    <tr>
      <td></td>
      <td><?php echo $adm_bgcolor; ?></td>
      <td><?php echo $adm_fontcol; ?></td>
      <td><?php echo $adm_fontsize; ?></td>
      <td><?php echo $adm_fontfam; ?></td>
    </tr>
    <tr>
    <tr>
      <td><?php echo $adm_headline; ?></td>
      <td><input type="text" size="15" name="bg_hc" maxlength="7" value="<?php echo $row['bg_hc']; ?>" class="colorpicker" /></td>
      <td><input type="text" size="15" name="fc_hc" maxlength="7" value="<?php echo $row['fc_hc']; ?>" class="colorpicker" /></td>
      <td><input type="text" size="15" name="fs_hc" value="<?php echo $row['fs_hc']; ?>" /></td>
      <td><input type="text" size="15" name="ff_hc" value="<?php echo $row['ff_hc']; ?>" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_leftcol; ?></td>
      <td><input type="text" size="15" name="bg_lc" maxlength="7" value="<?php echo $row['bg_lc']; ?>" class="colorpicker" /></td>
      <td><input type="text" size="15" name="fc_lc" maxlength="7" value="<?php echo $row['fc_lc']; ?>" class="colorpicker" /></td>
      <td><input type="text" size="15" name="fs_lc" value="<?php echo $row['fs_lc']; ?>" /></td>
      <td><input type="text" size="15" name="ff_lc" value="<?php echo $row['ff_lc']; ?>"" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_rightcol; ?></td>
      <td><input type="text" size="15" name="bg_rc" maxlength="7" value="<?php echo $row['bg_rc']; ?>" class="colorpicker" /></td>
      <td><input type="text" size="15" name="fc_rc" maxlength="7" value="<?php echo $row['fc_rc']; ?>" class="colorpicker" /></td>
      <td><input type="text" size="15" name="fs_rc" value="<?php echo $row['fs_rc']; ?>" /></td>
      <td><input type="text" size="15" name="ff_rc" value="<?php echo $row['ff_rc']; ?>" /></td>
    </tr>
  </table>

  <table>
    <tr>
      <th colspan="2"><?php echo $adm_css; ?></th>
    </tr>
    <tr>
      <td><textarea name="css" cols="30" rows="6"><?php echo $row['css']; ?></textarea></td>
      <td><?php echo $adm_info_css; ?></td>
    </tr>
  </table>

  <p><input type="submit" value="<?php echo $buttonsend; ?>" name="submit" /></p>
  </form>

  <p><?php echo $adm_info_colors; ?></p>

<?php }



  
// Smileys
if ($section == "smileys") {

  if (isset($_POST['submitset'])) {

    echo "<p>".$adm_save."</p>";

    $up_smileypos = (int)$_POST['smileypos'];
    $up_smileyrow = (int)$_POST['smileyrow'];

    $sql = "UPDATE ".$pre."settings SET smileypos = '$up_smileypos', smileyrow = '$up_smileyrow'";
    mysql_query($sql) or die();
    
    echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=smileys\">";

  } ?>

  <form method="post" action="admin.php?section=smileys">
  <table>
    <tr>
      <th colspan="2"><?php echo $adm_navi_settings; ?></th>
    </tr>
    <tr>
      <td><?php echo $adm_position; ?></td>
      <td><input type="radio" name="up_smileypos" value="2" <?php if ($smileypos == "2") { echo "checked=\"checked\""; } ?> /><?php echo $adm_right; ?>
	  <input type="radio" name="up_smileypos" value="1" style="margin-left: 20px;" <?php if ($smileypos == "1") { echo "checked=\"checked\""; } ?> /><?php echo $adm_bottom; ?></td>
    </tr>
    <tr>
      <td><?php echo $adm_smileyrow; ?></td>
      <td><input type="radio" name="up_smileyrow" <?php if ($smileyrow != "0") { echo "checked=\"checked\""; } ?> /><?php echo $adm_manual; ?>: <input type="text" name="up_smileyrow" value="<?php echo $smileyrow; ?>" style="width: 20px;" />
	    <input type="radio" name="up_smileyrow" value="0" style="margin-left: 30px;" <?php if ($smileyrow == "0") { echo "checked=\"checked\""; } ?> /><?php echo $adm_auto; ?></td>
    </tr>
    <tr>
      <th colspan="2"><input type="submit" name="submitset" value="<?php echo $buttonsend; ?>" /></th>
    </tr>
  </table>
  </form><?php
  
  $sql = "SELECT * FROM ".$pre."smileys";
  $result = mysql_query($sql);
  mysql_query($sql);
    
  if(!mysql_num_rows($result)) {
    echo $adm_nosmileys;
  } else { ?>

    <table style="text-align: center;">
      <tr>
	<th width="100px">Smiley</th>
	<th width="100px">Code</th>
	<th width="100px"><?php echo $adm_actions; ?></th>
      </tr>

      <?php while ($row = mysql_fetch_assoc($result)) { ?>
	<tr>
	  <td><?php if (file_exists("images/smileys/".$row['smileyimg'])) { ?><img src="images/smileys/<?php echo $row['smileyimg']; ?>" alt ="" title="<?php echo $row['smileyimg']; ?>" /><?php } else { echo "n/a"; } ?></td>
	  <td><?php echo $row['smileycode']; ?></td>
	  <td><a href="admin.php?section=smileyedit&id=<?php echo $row['ID']; ?>"><img src="images/edit.gif" alt="edit" title="edit" /></a> <a href="admin.php?section=smileydelete&id=<?php echo $row['ID']; ?>"><img src="images/delete.gif" /></a></td>
	</tr>
      <?php } ?>
      
    </table>
      
  <?php } 

  if (isset($_POST['submitnew'])) {

    $up_smileycode = mysql_real_escape_string(strip_tags($_POST['up_smileycode']));
    $dir = "images/smileys/";
    $file = basename($_FILES['smileyfile']['name']);
    $typ = @getimagesize($_FILES['smileyfile']['tmp_name']);

    if ($up_smileycode == "") {
      echo "<p>".$adm_err_smilcode."</p>";
    } elseif (empty($_FILES['smileyfile']['name'])) {
      echo "<p>".$adm_err_nofile."</p>";
    } elseif ($typ[2] != 1 and $typ[2] != 2 and $typ[2] != 3) {
      echo "<p>".$adm_err_filetype."</p>";
    } elseif ($_FILES['smileyfile']['size'] >  102400) {
      echo "<p>".$adm_err_filesize."</p>";
    } elseif (!move_uploaded_file($_FILES['smileyfile']['tmp_name'], $dir.$file)) {
      echo "<p>".$adm_err_upload."</p>";
    } else {

      echo "<p>".$adm_save."</p>";

      $sql = "INSERT INTO ".$pre."smileys (smileyimg, smileycode) VALUES ('$file', '$up_smileycode')";
      mysql_query($sql);
      echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=smileys\">";

    }

  } ?>

  <form action="admin.php?section=smileys" method="POST" enctype="multipart/form-data">
    <table>
      <tr>
	<th colspan ="2"><?php echo $adm_newsmiley; ?></th>
      </tr>
      <tr>
	<td width="100px"><?php echo $adm_graphic; ?>:</td>
	<td width="200px"><input type="file" name="smileyfile" /><br /><br />
			    <i><?php echo $adm_info_smiley; ?></i>
      </tr>
      <tr>
	<td>Code:</td>
	<td><input type="text" size="30" name="up_smileycode" value="<?php if (isset($up_smileycode)) { echo $up_smileycode; } ?>" /></td>
      </tr>
      <tr>
	<th colspan="2"><input type="submit" value="<?php echo $buttonsend; ?>" name="submitnew" /></th>
      </tr>
    </table>
   </form>

<?php }



// Smileys bearbeiten
if ($section == "smileyedit") {

  if (isset($_POST['submit'])) {

    $id = (int)$_GET['id'];
    $smileycode = mysql_real_escape_string(strip_tags($_POST['smileycode']));
    $smileyimg = mysql_real_escape_string(strip_tags($_POST['smileyimg']));

    if ($smileyimg == "" or $smileycode == "") {
      echo "<p>".$adm_err_bothfields."</p>"; 
    } else {

      echo "<p>".$adm_save."</p>";

      $sql = "UPDATE
 		".$pre."smileys
	      SET
		smileyimg = '$smileyimg',
		smileycode = '$smileycode'
	      WHERE 
		ID = '$id'";

      mysql_query($sql);

      echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=smileys\">";

    }

  }
  
  $id = (int)$_GET['id'];
  $sql = "SELECT * FROM ".$pre."smileys WHERE ID = '$id'";
  $result = mysql_query($sql);
  $row = mysql_fetch_assoc($result); ?>
    
  <form action="admin.php?section=smileyedit&id=<?php echo $row['ID']; ?>" method="POST">
  <table>
    <tr>
      <th colspan="2"><?php echo $adm_editsmiley; ?></th>
    </tr>
    <tr>
      <td width="160px"><?php echo $adm_filename; ?>:</td>
      <td width="200px"><input size="30" name="smileyimg" value="<?php echo $row['smileyimg']; ?>" /></td>
    </tr>
    <tr>
      <td>Code:</td>
      <td><input size="30" name="smileycode" value="<?php echo $row['smileycode']; ?>" /></td>
    </tr>
    <tr>
      <th colspan="2"><input type="submit" value="Abschicken" name="submit"/></th>
    </tr>
  </table></form>

<?php }



// Smiley lschen
if ($section == "smileydelete") {

  echo "<p>".$adm_save."</p>";

  $id = (int)$_GET['id'];
  $sqlfile = "SELECT smileyimg FROM ".$pre."smileys WHERE ID = '$id'";
  $filearray = mysql_fetch_assoc(mysql_query($sqlfile));
  $file = $filearray['smileyimg'];

  $sql = "DELETE FROM ".$pre."smileys WHERE ID = '$id'";
  mysql_query($sql);

  unlink("images/smileys/".$file);
    
  echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=smileys\">";

}




// Badwords

if ($section == "badwords") {

  if (isset($_POST['submit'])) {

    $badword = mysql_real_escape_string(strip_tags($_POST['badword']));
    $ersatz = mysql_real_escape_string(strip_tags($_POST['ersatz']));

    if (empty($badword) or empty($ersatz)) {
      echo"<p>".$adm_err_bothfields."</p>";
    } else { 

      $sql = "INSERT INTO ".$pre."badwords (
		Badword,
		Ersatz )
	      VALUES (
		'$badword',
		'$ersatz')";

      mysql_query($sql);
      echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=badwords\">";

    }

  }


  $sql = "SELECT * FROM ".$pre."badwords ORDER BY badword";
  $result = mysql_query($sql);

  if(!mysql_num_rows($result)) {
    echo "<p>".$adm_nobad."</p>";
  } else { ?>

    <table style="text-align: center;">
      <tr>
	<th width="180px">Badword</th>
	<th width="180px"><?php echo $adm_alter; ?></th>
	<th width="50px"><?php echo $adm_actions; ?></th>
      </tr>

      <?php while ($row = mysql_fetch_assoc($result)) { ?>
	<tr>
          <td><?php echo $row['Badword']; ?></td>
	  <td><?php echo $row['Ersatz']; ?></td>
	  <td><a href="admin.php?section=badwordedit&id=<?php echo $row['ID']; ?>"><img src="images/edit.gif" alt="edit" title="edit" /></a> <a href="admin.php?section=badworddelete&id=<?php echo $row['ID']; ?>"><img src="images/delete.gif" /></a></th>
	</tr>
      <?php } ?>

    </table>

  <?php } ?>


  <form action="admin.php?section=badwords" method="POST">
  <table>
    <tr>
      <th colspan ="2"><?php echo $adm_newbad; ?></th>
    </tr>
    <tr>
      <td width="100px">Badword:</td>
      <td width="200px"><input type="text" size="30" name="badword" /></td>
    </tr>
    <tr>
      <td><?php echo $adm_alter; ?>:</td>
      <td><input type="text" size="30" name="ersatz" /></td>
    </tr>
    <tr>
      <th colspan="2"><input type="submit" value="<?php echo $buttonsend; ?>" name="submit" /></th>
    </tr>
  </table>
  </form>

<?php }




// Badword editieren
if ($section == "badwordedit") {

  if (isset($_POST['submit'])) {

    $id = (int)$_GET['id'];
    $badword = mysql_real_escape_string(strip_tags($_POST['badword']));
    $ersatz = mysql_real_escape_string(strip_tags($_POST['ersatz']));

    if ($badword == "" or $ersatz == "") {
      echo "<p>".$adm_err_bothfields."</p>";
    } else {
      echo "<p>".$adm_save."</p>";

      $sql = "UPDATE
		".$pre."badwords
	      SET
		Badword = '$badword',
		Ersatz = '$ersatz'
	      WHERE 
		ID = '$id'";

      mysql_query($sql);
      
      echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=badwords\">";

    }

  }

  $id = (int)$_GET['id'];
  $sql = "SELECT * FROM ".$pre."badwords WHERE ID = '$id'";
  $result = mysql_query($sql);
  $row = mysql_fetch_assoc($result); ?>
    
  <form action="admin.php?section=badwordedit&id=<?php echo $id; ?>" method="POST">
  <table>
    <tr>
      <th colspan="2"><?php echo $adm_editbad; ?></th>
    <tr>
      <td width="160px">Badword:</td>
      <td width="200px"><input size="30" name="badword" value="<?php echo $row['Badword']; ?>" /></td>
    </tr>
    <tr>
      <td>Code:</td>
      <td><input size="30" name="ersatz" value="<?php echo $row['Ersatz']; ?>" /></td>
    </tr>
    <tr>
      <th colspan="2"><input type="submit" value="<?php echo $buttonsend; ?>" name="submit" /></th>
    </tr>
  </table>
  </form>

<?php }




if ($section == "badworddelete") {

  echo "<p>".$adm_save."</p>";

  $id = (int)$_GET['id'];

  $sql = "DELETE FROM ".$pre."badwords WHERE ID = '$id'";
  mysql_query($sql);

  echo "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php?section=badwords\">";

}




// Support

if ($section == "support") { 

  if (isset($_POST['submit'])) {
    $question = $_POST['question'];
    $mail = "icybook@web.de";
    $subj = "Frage zum Icybook";
    $message = $lang['adminmail']." schreibt:\n\n".$question;
    $headers = array();
    $headers[] = "Subject: ".$ind_newentry_mailsubject;
    $headers[] = "Content-type: text/html";
    $headers[] = "From: Icybook";
    $header = implode("\r\n", $headers);

    if (mail($mail, $subj, $message, $header)) {
      echo "<p><b>Mail gesendet!</b></p>";
    }

  } else { ?>

    <p><br /><?php echo $adm_form; ?></p>

    <form method="post" action="admin.php?section=support">
    <table>
      <tr>
	<th colspan="2">Support</th>
      </tr>
      <tr>
	<td><?php echo $adm_question; ?>:</td>
	<td><textarea name="question" cols="40" rows="8"></textarea>
      </tr>
      <tr>
	<th colspan="2"><input type="submit" name="submit" value="<?php echo $buttonsend; ?>" />
      </tr>
    </form></table>

  <?php }

} 


echo "</div>";

echo "<div id=\"adminfooter\">Icybook ".$version." ".$adm_center."</a> | <a href=\""; if ($path == "") { echo "index.php"; } else { echo $gburl; } echo "\" target=\"_blank\">".$adm_togb."</a> | <a href=\"admin.php?section=support\">Support</a> | <a href=\"http://facebook.com/icybook\" title=\"Facebook\" target=\"_blank\">Facebook</a> | <a href=\"admin.php?section=logout\">Logout</a></div></div>";




} else {

  echo "<p>".$adm_notloggedin;
    if ($path == "") {
      echo " (<a href=\"".$gburl."\">".$adm_backtogb."</a>)</p>";
    } else {
      echo " (<a href=\"".$lang['gburl']."\">".$adm_backtogb."</a>)</p>";
    }
} ?>

</body>
</html>